package com.example.matuletest

import cafe.adriel.voyager.core.model.ScreenModel
import cafe.adriel.voyager.core.model.screenModelScope
import kotlinx.coroutines.CloseableCoroutineDispatcher
import kotlinx.coroutines.CoroutineDispatcher
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.launch

class ViewModelBase(private val coroutineDispatcher: CoroutineDispatcher):ScreenModel {
    val errorMessage = MutableStateFlow<String?>(null)

    fun auth(email: String, password: String){
        if(!validateEmail(email)){
            screenModelScope.launch(coroutineDispatcher) {
                errorMessage.emit("email error")
            }
            return
        }

    }

    private fun validateEmail(email:String) = email.isNotEmpty()
}