package com.example.matuletest.ui.auth

import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.example.matuletest.domain.AuthUseCase
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.update
import kotlinx.coroutines.launch

class AuthScreenViewModel: ViewModel() {
     val authScreenState = MutableStateFlow(AuthScreenState())
     val useCase = AuthUseCase()
    fun setPassword(password: String){
        viewModelScope.launch {
            authScreenState.update {
                it.copy(password = password)
            }
        }
    }
    fun setEmail(email: String){
        viewModelScope.launch {
            authScreenState.update {
                it.copy(email = email)
            }
        }
    }

    fun auth(){
        viewModelScope.launch {
            useCase.auth(
                authScreenState.value.email,
                authScreenState.value.password
            ).collect{ result ->
                    if(result) authScreenState.update { it.copy(isSignIn = true) }
                }
        }
    }
}